/* 
 * keypad
 *
 * A suite of communication APIs for web and enterprise applications
 *
 * OpenAPI spec version: v1
 * Contact: fmalka@modulo.co.il
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = SeriousSIP.Client.SwaggerDateConverter;

namespace SeriousSIP.Model
{
    /// <summary>
    /// id - The unique ID of the message.    from - For inbound messages, represent the number sending the message, for outbound messages, represent the sip uri identity of the sender.    to - The sip uri represnting the destination of the call.    direction - In for inbound message and Out for outbound message.    message - The string containing the instant message.
    /// </summary>
    [DataContract]
        public partial class InboundMessagesSubscriptions :  IEquatable<InboundMessagesSubscriptions>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="InboundMessagesSubscriptions" /> class.
        /// </summary>
        /// <param name="onMessageReceived">onMessageReceived.</param>
        /// <param name="onTextMessageReceived">onTextMessageReceived.</param>
        public InboundMessagesSubscriptions(string onMessageReceived = default(string), string onTextMessageReceived = default(string))
        {
            this.OnMessageReceived = onMessageReceived;
            this.OnTextMessageReceived = onTextMessageReceived;
        }
        
        /// <summary>
        /// Gets or Sets OnMessageReceived
        /// </summary>
        [DataMember(Name="onMessageReceived", EmitDefaultValue=false)]
        public string OnMessageReceived { get; set; }

        /// <summary>
        /// Gets or Sets OnTextMessageReceived
        /// </summary>
        [DataMember(Name="onTextMessageReceived", EmitDefaultValue=false)]
        public string OnTextMessageReceived { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class InboundMessagesSubscriptions {\n");
            sb.Append("  OnMessageReceived: ").Append(OnMessageReceived).Append("\n");
            sb.Append("  OnTextMessageReceived: ").Append(OnTextMessageReceived).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as InboundMessagesSubscriptions);
        }

        /// <summary>
        /// Returns true if InboundMessagesSubscriptions instances are equal
        /// </summary>
        /// <param name="input">Instance of InboundMessagesSubscriptions to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(InboundMessagesSubscriptions input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.OnMessageReceived == input.OnMessageReceived ||
                    (this.OnMessageReceived != null &&
                    this.OnMessageReceived.Equals(input.OnMessageReceived))
                ) && 
                (
                    this.OnTextMessageReceived == input.OnTextMessageReceived ||
                    (this.OnTextMessageReceived != null &&
                    this.OnTextMessageReceived.Equals(input.OnTextMessageReceived))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.OnMessageReceived != null)
                    hashCode = hashCode * 59 + this.OnMessageReceived.GetHashCode();
                if (this.OnTextMessageReceived != null)
                    hashCode = hashCode * 59 + this.OnTextMessageReceived.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
